package org.openxma.dsl.core.generator;

import java.io.IOException;

import org.eclipse.emf.codegen.ecore.genmodel.GenModel;
import org.eclipse.emf.codegen.ecore.genmodel.GenPackage;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.mwe.core.ConfigurationException;
import org.eclipse.xtext.Grammar;

public class EcoreGeneratorFragment extends org.eclipse.xtext.generator.ecore.EcoreGeneratorFragment {

	protected GenModel getSaveAndReconcileGenModel(ResourceSet rs, Grammar grammar,
			org.eclipse.xpand2.XpandExecutionContext ctx, java.util.List<EPackage> packs,
			java.util.List<GenPackage> usedGenPackages) throws ConfigurationException {

		GenModel genModel = null;

		genModel = getGenModel(rs, grammar, ctx, packs);
		genModel.initialize(packs);
		for (GenPackage genPackage : genModel.getGenPackages()) {
			genPackage.setBasePackage(getBasePackage(grammar));
			genPackage.setClassPackageSuffix("model.impl");
			genPackage.setInterfacePackageSuffix("model");
		}
		genModel.getUsedGenPackages().addAll(usedGenPackages);
		resolveAll(rs);
		try {
			genModel.eResource().save(null);
		} catch (IOException e) {
			throw new WrappedException(e);
		}
		return genModel;
	};

}
