/**
 * <copyright>
 * </copyright>
 *
 * $Id: ValidatorReferenceImpl.java 8328 2011-08-29 13:37:02Z mjohannes $
 */
package org.openxma.dsl.core.model.impl;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.openxma.dsl.core.CorePackage;
import org.openxma.dsl.core.model.ParameterDefinition;
import org.openxma.dsl.core.model.ReferenceWithParameter;
import org.openxma.dsl.core.model.Validator;
import org.openxma.dsl.core.model.ValidatorReference;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Validator Reference</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.core.model.impl.ValidatorReferenceImpl#getValidator <em>Validator</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ValidatorReferenceImpl extends ReferenceWithParameterImpl implements ValidatorReference {
	/**
     * The cached value of the '{@link #getValidator() <em>Validator</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getValidator()
     * @generated
     * @ordered
     */
	protected Validator validator;

	/**
	 * 
	 * @modified
	 */
	protected ValidatorReference validatorReference;

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	protected ValidatorReferenceImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return CorePackage.Literals.VALIDATOR_REFERENCE;
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public Validator getValidator() {
        if (validator != null && validator.eIsProxy()) {
            InternalEObject oldValidator = (InternalEObject)validator;
            validator = (Validator)eResolveProxy(oldValidator);
            if (validator != oldValidator) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, CorePackage.VALIDATOR_REFERENCE__VALIDATOR, oldValidator, validator));
            }
        }
        return validator;
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public Validator basicGetValidator() {
        return validator;
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public void setValidator(Validator newValidator) {
        Validator oldValidator = validator;
        validator = newValidator;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.VALIDATOR_REFERENCE__VALIDATOR, oldValidator, validator));
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case CorePackage.VALIDATOR_REFERENCE__VALIDATOR:
                if (resolve) return getValidator();
                return basicGetValidator();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case CorePackage.VALIDATOR_REFERENCE__VALIDATOR:
                setValidator((Validator)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case CorePackage.VALIDATOR_REFERENCE__VALIDATOR:
                setValidator((Validator)null);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case CorePackage.VALIDATOR_REFERENCE__VALIDATOR:
                return validator != null;
        }
        return super.eIsSet(featureID);
    }

	/**
	 * @generated NOT
	 * @return
	 */
	@Override
	public List<ReferenceWithParameter> getDefinitionStack() {
		if (definitionStack == null) {
			definitionStack = new ArrayList<ReferenceWithParameter>();
			definitionStack.add(this);
			ValidatorReference referenceToSuperValidator = getValidator().getSuperValidator();// .getValidatorParameter();//((SimpleType)getDataType()).getTypeDefinition();
			if (referenceToSuperValidator != null) {
				// TODO: check
				// DataTypeAndTypeParameter baseDef =
				// typeDefinition.getDefinition();
				definitionStack.addAll(referenceToSuperValidator.getDefinitionStack());
			}
		}
		return definitionStack;
	}

	/**
	 * @generated NOT
	 * @return
	 */
	@Override
	public List<ParameterDefinition> getParameterDefinitions() {
		Validator validator = getValidator();
		if (validator != null) {
			return validator.getValidatorParameter();
		}
		return null;
	}

	/**
	 * 
	 * @generated NOT
	 * @return
	 */
	public ValidatorReference getRootValidatorReference() {
		if (validatorReference == null) {
			List<ReferenceWithParameter> stack = getDefinitionStack();
			if (stack != null && stack.size() > 0) {
				ReferenceWithParameter referenceWithParameter = stack.get(stack.size() - 1);
				if (referenceWithParameter instanceof ValidatorReference) {
					validatorReference = (ValidatorReference) referenceWithParameter;
				} else {
					throw new RuntimeException("Next element in definition-stack is of unexpected type");
				}
			}
		}
		return validatorReference;
	}
	
	/**
	 * 
	 * @generated NOT
	 */
	public boolean isStringValidator() {
		String validatorName = getRootValidatorName();
		return STRING_VALIDATOR.equals(validatorName);
	}

	/**
	 * 
	 * @generated NOT
	 */
	public boolean isCustomValidator() {
		String validatorName = getRootValidatorName();
		return CUSTOM_VALIDATOR.equals(validatorName);
	}

	/**
	 * 
	 * @generated NOT
	 */
	public boolean isDateValidator() {
		String validatorName = getRootValidatorName();
		return DATE_VALIDATOR.equals(validatorName);
	}

	/**
	 * 
	 * @generated NOT
	 */
	public boolean isNumberValidator() {
		String validatorName = getRootValidatorName();
		return NUMBER_VALIDATOR.equals(validatorName);
	}

	/**
	 * 
	 * @generated NOT
	 */
	public boolean isUserDefinedValidator() {
		String validatorName = getRootValidatorName();
		return !VALIDATOR_2_TYPE_MAPPING.keySet().contains(validatorName);
	}

	/**
	 * 
	 * @generated NOT
	 */
	public boolean isTimeStampValidator() {
		String validatorName = getRootValidatorName();
		return TIME_STAMP_VALIDATOR.equals(validatorName);
	}

	/**
     * @generated NOT
     */
    public boolean isBooleanValidator() {
        String validatorName = getRootValidatorName();
        return BOOLEAN_VALIDATOR.equals(validatorName);
    }

    /**
     * @generated NOT
     */
    public boolean isI18nValidator() {
        String validatorName = getRootValidatorName();
        return I18N_ENUMERATION_VALIDATOR.equals(validatorName);
    }
    
    /**
     * @generated NOT
     */
    private String getRootValidatorName() {
        ValidatorReference rootValidatorReference = getRootValidatorReference();
        String validatorName = rootValidatorReference.getValidator().getName();
        return validatorName;
    }

} // ValidatorReferenceImpl
